<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for Arrivee StructType
 * @subpackage Structs
 */
class Arrivee extends AbstractStructBase
{
    /**
     * The EstApresMinuit
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 1
     * @var bool
     */
    public $EstApresMinuit;
    /**
     * The Mode
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Mode;
    /**
     * The Destination
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Destination;
    /**
     * The Horaire
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Horaire;
    /**
     * Constructor method for Arrivee
     * @uses Arrivee::setEstApresMinuit()
     * @uses Arrivee::setMode()
     * @uses Arrivee::setDestination()
     * @uses Arrivee::setHoraire()
     * @param bool $estApresMinuit
     * @param string $mode
     * @param string $destination
     * @param string $horaire
     */
    public function __construct($estApresMinuit = null, $mode = null, $destination = null, $horaire = null)
    {
        $this
            ->setEstApresMinuit($estApresMinuit)
            ->setMode($mode)
            ->setDestination($destination)
            ->setHoraire($horaire);
    }
    /**
     * Get EstApresMinuit value
     * @return bool
     */
    public function getEstApresMinuit()
    {
        return $this->EstApresMinuit;
    }
    /**
     * Set EstApresMinuit value
     * @param bool $estApresMinuit
     * @return \StructType\Arrivee
     */
    public function setEstApresMinuit($estApresMinuit = null)
    {
        // validation for constraint: boolean
        if (!is_null($estApresMinuit) && !is_bool($estApresMinuit)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a bool, "%s" given', gettype($estApresMinuit)), __LINE__);
        }
        $this->EstApresMinuit = $estApresMinuit;
        return $this;
    }
    /**
     * Get Mode value
     * @return string|null
     */
    public function getMode()
    {
        return $this->Mode;
    }
    /**
     * Set Mode value
     * @param string $mode
     * @return \StructType\Arrivee
     */
    public function setMode($mode = null)
    {
        // validation for constraint: string
        if (!is_null($mode) && !is_string($mode)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mode)), __LINE__);
        }
        $this->Mode = $mode;
        return $this;
    }
    /**
     * Get Destination value
     * @return string|null
     */
    public function getDestination()
    {
        return $this->Destination;
    }
    /**
     * Set Destination value
     * @param string $destination
     * @return \StructType\Arrivee
     */
    public function setDestination($destination = null)
    {
        // validation for constraint: string
        if (!is_null($destination) && !is_string($destination)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($destination)), __LINE__);
        }
        $this->Destination = $destination;
        return $this;
    }
    /**
     * Get Horaire value
     * @return string|null
     */
    public function getHoraire()
    {
        return $this->Horaire;
    }
    /**
     * Set Horaire value
     * @param string $horaire
     * @return \StructType\Arrivee
     */
    public function setHoraire($horaire = null)
    {
        // validation for constraint: string
        if (!is_null($horaire) && !is_string($horaire)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($horaire)), __LINE__);
        }
        $this->Horaire = $horaire;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\Arrivee
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
