<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for CredentialHeader StructType
 * Meta informations extracted from the WSDL
 * - type: tns:CredentialHeader
 * @subpackage Structs
 */
class CredentialHeader extends AbstractStructBase
{
    /**
     * The ID
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $ID;
    /**
     * The MDP
     * Meta informations extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $MDP;
    /**
     * Constructor method for CredentialHeader
     * @uses CredentialHeader::setID()
     * @uses CredentialHeader::setMDP()
     * @param string $iD
     * @param string $mDP
     */
    public function __construct($iD = null, $mDP = null)
    {
        $this
            ->setID($iD)
            ->setMDP($mDP);
    }
    /**
     * Get ID value
     * @return string|null
     */
    public function getID()
    {
        return $this->ID;
    }
    /**
     * Set ID value
     * @param string $iD
     * @return \StructType\CredentialHeader
     */
    public function setID($iD = null)
    {
        // validation for constraint: string
        if (!is_null($iD) && !is_string($iD)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($iD)), __LINE__);
        }
        $this->ID = $iD;
        return $this;
    }
    /**
     * Get MDP value
     * @return string|null
     */
    public function getMDP()
    {
        return $this->MDP;
    }
    /**
     * Set MDP value
     * @param string $mDP
     * @return \StructType\CredentialHeader
     */
    public function setMDP($mDP = null)
    {
        // validation for constraint: string
        if (!is_null($mDP) && !is_string($mDP)) {
            throw new \InvalidArgumentException(sprintf('Invalid value, please provide a string, "%s" given', gettype($mDP)), __LINE__);
        }
        $this->MDP = $mDP;
        return $this;
    }
    /**
     * Method called when an object has been exported with var_export() functions
     * It allows to return an object instantiated with the values
     * @see AbstractStructBase::__set_state()
     * @uses AbstractStructBase::__set_state()
     * @param array $array the exported values
     * @return \StructType\CredentialHeader
     */
    public static function __set_state(array $array)
    {
        return parent::__set_state($array);
    }
    /**
     * Method returning the class name
     * @return string __CLASS__
     */
    public function __toString()
    {
        return __CLASS__;
    }
}
